// C Header File
// Created 02/03/2003; 15:51:54

//===================================================================================//

void Attend(short temps)
{
	asm("	0:	move.w	#3000,%%d0
				1:	dbra		%%d0,1b
						dbra		%0,0b
			"::"d"(temps):"d0");
}

//===================================================================================//

//===================================================================================//
//																																					  			 //
//			Option 1: efface l'cran sur les deux plans.												  			 //
//			Option 2: efface seulement le rectangle du menu sur les deux plans.	  			 //
//																																					  			 //
//===================================================================================//

#define EFFACE_DEUX_PLANS		1
#define EFFACE_RECT_MENU		2

//===================================================================================//

void FonduBas(short option)
{
	register short i;
	
	for(i = 0; i <= 8; i ++)
	{
	  Attend(2);
	  OSContrastDn();
	}
	
	switch(option)
	{
		case EFFACE_DEUX_PLANS:
		EffacePlans();
		break;
		case EFFACE_RECT_MENU:
		GrayFastFillRect_R(plan0, plan1, 16+ADAPT_x, 16+ADAPT_y, 143+ADAPT_x, 83+ADAPT_y, COLOR_WHITE);
	  break;
	}
	Attend(6);
}

//===================================================================================//

void FonduHaut(void)
{
	register short i;
	
	for(i = 0; i <= 8; i ++)
	{
		Attend(2);
		OSContrastUp();
	}
	
	PressionTouche(TESTE_ET_SORT);
}

//===================================================================================//

void FondEcran(void) // Fond d'cran pour les TI-92/92+/V200
{
	register short i, j;
	
	GrayClearScreen2B_R(plan0, plan1);
  
	for(i = 0; i <= 239; i += 8)
	 {
		for(j = 0; j <= 127; j +=8)
		 {
			 GraySprite8_OR_R(i, j, 8, fond_0, fond_1, plan0, plan1);
		 }
	 }
}

//===================================================================================//

void EnterEsc(void)
{
	do
	{
		PressionTouche(NE_FAIT_RIEN);
	}while(!ESCAPE && !ENTER && !SECOND);
}

//===================================================================================//

void AfficheQuit(short *game_over)
{
	unsigned char buffer[2*LCD_SIZE];
	register short y_quit;
	
	y_quit = 43;
	
	SauveImg(buffer);
	DessineRectPlein(0, 0, 159, 100, 2, GRIS_CLAIR);
	DessineRectPlein(0, 0, 159, 100, 2, GRIS_FONCE);
	DessineRectPlein(39, 27, 120, 67, 0, GRIS_CLAIR);
	DessineRectPlein(39, 27, 120, 67, 0, GRIS_FONCE);
	DessineContourRect(40, 28, 119, 66, 4, GRIS_CLAIR);
	DessineContourRect(40, 28, 119, 66, 4, GRIS_FONCE);
	DessineRectPlein(41, 29, 118, 41, 4, GRIS_FONCE);
	AfficheChaine(56, 30, "ABORT?", 2, GRIS_FONCE, GROS);
	AfficheChaine(57, 31, "ABORT?", 2, GRIS_CLAIR, GROS);
	DessineRectPlein(41, 42, 118, 65, 4, GRIS_CLAIR);
	AfficheChaine(67, 44, "Yes", 2, GRIS_CLAIR, GROS);
	AfficheChaine(67, 44, "Yes", 4, GRIS_FONCE, GROS);
	AfficheChaine(71, 55, "No", 2, GRIS_CLAIR, GROS);
	AfficheChaine(71, 55, "No", 4, GRIS_FONCE, GROS);
	DessineRectPlein(43, y_quit, 116, y_quit+10, 2, GRIS_FONCE);
	
	do
	{
		PressionTouche(TESTE_ET_SORT);
		if(BAS || HAUT)
		{
			DessineRectPlein(43, y_quit, 116, y_quit+10, 2, GRIS_FONCE);
			y_quit = (y_quit == 43 ? 54: 43);
			DessineRectPlein(43, y_quit, 116, y_quit+10, 2, GRIS_FONCE);
		}
	}while(!ENTER && !SECOND && !ESCAPE);
	
	RestaureImg(buffer);
	
	if(y_quit == 43 && (ENTER || SECOND))
	{
		* game_over = 1;
	}
	 
}

//===================================================================================//

void AfficheMessage(const char * string)
{
	DessineRectPlein(1, 40, 158, 55, 0, GRIS_CLAIR);
	DessineRectPlein(1, 40, 158, 55, 0, GRIS_FONCE);
	DessineContourRect(1, 40, 158, 55, 4, GRIS_FONCE);
	DessineContourRect(1, 40, 158, 55, 4, GRIS_CLAIR);
	DessineRectPlein(3, 42, 156, 53, 4, GRIS_FONCE);
	AfficheChaine((160-DrawStrWidth(string,2))/2, 43, string, 2, GRIS_FONCE, GROS);
	AfficheChaine((162-DrawStrWidth(string,2))/2, 44, string, 2, GRIS_CLAIR, GROS);	
}

//===================================================================================//

void DessineBlocs(short hauteur)
{
	register short y_piece, piece, i, j;
	
	y_piece = 96-6*hauteur;
	
	for(i = 1; i <= hauteur; i++)
	{
		for(j = 16; j <= 88; j += 8)
		{
			piece = random(20);
			piece = (piece >= 13? 0: piece);
			Sprite8_GRIS_OR(j, y_piece+6*(i-1), motifs_0[piece], motifs_1[piece]);
		}
	}
	
}

//===================================================================================//

void DessineHauteur(char high_blocs)
{
	DessineRectPlein(102, 0, 106, 95, 0, GRIS_CLAIR);
	DessineRectPlein(102, 0, 106, 95, 0, GRIS_FONCE);
	DessineRectPlein(103, high_blocs+2, 106, 95, 4, GRIS_FONCE);
	DessineContourRect(102, high_blocs+1, 106, 95, 4, GRIS_CLAIR);
}

//===================================================================================//

void DessineFin(short wins, short losses)
{
	register short i;
	
	FonduBas(EFFACE_DEUX_PLANS);
	if(!TI89)
	{
		FondEcran();
		EffacePlans();
	}
	
	DessineRectPlein(0, 0, 159, 17, 4, GRIS_CLAIR);
	DessineRectPlein(0, 0, 159, 17, 4, GRIS_FONCE);
	DessineRectPlein(0, 82, 159,99, 4, GRIS_CLAIR);
	DessineRectPlein(0, 82, 159,99, 4, GRIS_FONCE);
	
	for(i = 0; i <= 9; i ++)
	{
		Sprite16_GRIS_XOR(16*i, 66, brique_0, brique_1);
	}
	
	DessineLigne(0, 66, 159, 66, GRIS_FONCE, 4);
	DessineRectPlein(4, 2, 45, 15, 0, GRIS_CLAIR);
	DessineRectPlein(4, 2, 45, 15, 0, GRIS_FONCE);
	DessineRectPlein(4, 84, 45, 97, 0, GRIS_CLAIR);
	DessineRectPlein(4, 84, 45, 97, 0, GRIS_FONCE);
	DessineRectPlein(60, 1, 139, 16, 0, GRIS_CLAIR);
	DessineRectPlein(60, 1, 139, 16, 0, GRIS_FONCE);
	DessineRectPlein(60, 83, 139, 98, 0, GRIS_CLAIR);
	DessineRectPlein(60, 83, 139, 98, 0, GRIS_FONCE);
	AfficheChaine(5, 87, joueur == MARIO? "MARIO": "LUIGI", 4, GRIS_CLAIR, GROS);
	AfficheChaine(5, 87, joueur == MARIO? "MARIO": "LUIGI", 4, GRIS_FONCE, GROS);
	AfficheChaine(5, 4, joueur == LUIGI? "MARIO": "LUIGI", 4, GRIS_CLAIR, GROS);
	AfficheChaine(5, 4, joueur == LUIGI? "MARIO": "LUIGI", 4, GRIS_FONCE, GROS);
	
	if(wins != 0)
	{
		for(i = 0; i <= (wins-1); i ++)
		{
			Sprite16_GRIS_XOR(62+20*i, 83, joueur == MARIO ? tete_mario_0: tete_luigi_0, joueur == MARIO ? tete_mario_1: tete_luigi_1);
		}
	}
	
	if(losses != 0)
	{
		for(i = 0; i <= (losses-1); i ++)
		{
			Sprite16_GRIS_XOR(62+20*i, 1, joueur == MARIO ? tete_luigi_0: tete_mario_0, joueur == MARIO ? tete_luigi_1: tete_mario_1);
		}
	}
	
	if(wins == losses)
	{
		AfficheChaine(40, 19, "DRAW GAME!", 4, GRIS_CLAIR, GROS);
		AfficheChaine(40, 19, "DRAW GAME!", 4, GRIS_FONCE, GROS);
		DessineLigne(41, 29, 117, 29, 4, GRIS_FONCE);
	}
	else if(wins > losses)
	{
		AfficheChaine(36, 19, joueur == MARIO ? "MARIO WINS!": "LUIGI WINS!", 4, GRIS_CLAIR, GROS);
		AfficheChaine(36, 19, joueur == MARIO ? "MARIO WINS!": "LUIGI WINS!", 4, GRIS_FONCE, GROS);
		DessineLigne(37, 29, 121, 29, 4, GRIS_FONCE);
		Sprite16_GRIS_XOR(45, 51, perd_petit_0, perd_petit_1);
		Sprite32_GRIS(80, 31, gagne_gros_0, gagne_gros_1);	  	
	}
	else if(wins < losses)
	{
		AfficheChaine(32, 19, joueur == MARIO ? "MARIO LOSES!": "LUIGI LOSES!", 4, GRIS_CLAIR, GROS);
		AfficheChaine(32, 19, joueur == MARIO ? "MARIO LOSES!": "LUIGI LOSES!", 4, GRIS_FONCE, GROS);
		DessineLigne(33, 29, 125, 29, 4, GRIS_FONCE);
		Sprite16_GRIS_XOR(45, 53, gagne_petit_0, gagne_petit_1);
		Sprite32_GRIS(80, 36, perd_gros_0, perd_gros_1);	
	}
	
	FonduHaut();
}

//===================================================================================//

void EnvoieByte(char *buffer, short var) // Envoie UN seul byte
{
	buffer[0] = (char)(var);
	OSWriteLinkBlock(buffer, 1);
}

//===================================================================================//

void EffetSprite(unsigned char *sprite_0, unsigned char *sprite_1)
{
	register short i;
	
	for(i = 0; i < 100; i ++)
	{
		memcpy(ADAPT_y*30+ADAPT_x/8+plan0+30*i, sprite_0+20*i, 20);
		memcpy(ADAPT_y*30+ADAPT_x/8+plan1+30*(99-i), sprite_1+20*(99-i), 20);
		Attend(2);
	}
}

//===================================================================================//

void EffetLCD(unsigned char *lcd_0, unsigned char *lcd_1)
{
	register short i;
	
	for(i = 0; i < 128; i ++)
	{
		memcpy(plan0+30*i, lcd_0+30*i, 30);
		memcpy(plan1+30*(127-i), lcd_1+30*(127-i), 30);
		Attend(2);
	}
}

//==========================================================================//

static inline void OuvreFichierSauvegarde(void)
{
	char extension[] = "SAV";
	char signature[] = "TETRV3";
	
	entry = DerefSym(SymFindMain(SYMSTR("tetsav")));
	
	if (entry != NULL)
	{
		Hsc = (unsigned char *)HLock(entry->handle);
		if (memcmp(Hsc+2, signature, 6) != 0)
		{
			HeapUnlock(entry->handle);
			goto Nouveau;
		}
		memcpy(options, Hsc+8, 10);
		memcpy(hscore, Hsc+18, 90);
	}
	else
	{
	  Nouveau:
		entry = DerefSym(SymAddMain(SYMSTR("tetsav")));
		Hsc = (unsigned char *)HLock(entry->handle = HeapAlloc(114));
		*(unsigned short *)Hsc = 112;
		strcpy(Hsc+2, signature);
		*(Hsc+108) = 0;
		strcpy(Hsc+109, extension);
		*(Hsc+112) = 0;
		*(Hsc+113) = OTH_TAG;
	}
}

//==========================================================================//

static inline void FermeFichierSauvegarde(void)
{
	memcpy(Hsc+8, options, 10);
	memcpy(Hsc+18, hscore, 90);
	HeapUnlock(entry->handle);
}

//==========================================================================//