//===================================================================================//

/* Numro de la version et date */

#define VERSION		"3.0"
#define DATE			"05/09/2005"

/* Adaptations pour fonctionner sur TI-89/92+/V200 */

#define ADAPT_x     (TI89 ? 0: 40)        // Adapte la largeur TI-89/TI-92+
#define ADAPT_y     (TI89 ? 0: 14)    		// Adapte la hauteur TI-89/TI-92+
#define NUM_COL     (TI89? 7: 10)         // Adapte le nombre de colonnes dans la matrice clavier
#define QUICK_EXIT	(TI89? 5: 1), (TI89? 6: 4) // [HOME]/[F8] pour TI-89/TI-92+
		
//===================================================================================//

/* Taille de la police */

#define PETIT				0
#define NORMAL			1
#define GROS				2

//===================================================================================//

/* Niveaux de gris */

#define GRIS_CLAIR	0
#define GRIS_FONCE  1

//===================================================================================//

/* Joueurs (en mode link) */

#define MARIO				1
#define LUIGI				2

//===================================================================================//
    																			    																			
typedef struct									// Structure des Highscores
  {
    unsigned char nom[13]; // 14 bytes
    unsigned long score; // 4 bytes
  } HIGH_SCORES;


static HIGH_SCORES hscore[5]={
{"------------", 5000},
{"-- A game --", 4000},
{"-programmed-", 3000},
{"-- by Nul --", 2000},
{"------------", 1000},
}; // 18x5 = 90 bytes

static short options[5] = {0, 0, 1, 0, 0};	// Liste de sauvegarde des options
// {"level", "high", "next", "shadow", "link"}
// 0 => ON
// 1 => OFF

#define level 	options[0]
#define high 		options[1] 
#define next 		options[2]
#define shadow 	options[3]
#define link 		options[4]


unsigned char * Sauvegarde = NULL; // Variable de sauvegarde pour une 'QUICK_EXIT_SAVE'
unsigned char * Hsc = NULL;
SYM_ENTRY * entry = NULL;
unsigned char * plan0 = NULL, * plan1 = NULL;
  						
//===================================================================================//   																			

INT_HANDLER int1 = NULL;
INT_HANDLER int2 = NULL;
INT_HANDLER int5 = NULL;
SCR_RECT ecran = {{0, 0, 239, 127}};
short joueur = 0;
short DROITE = 0;
short GAUCHE = 0;
short BAS = 0;
short HAUT = 0;
short ENTER = 0;
short ESCAPE = 0;
short SECOND = 0;
short SHIFT = 0;
short DIAMAND = 0;
short QUICK_EXIT_NO_SAVE = 0;
short QUICK_EXIT_SAVE = 0;

//===================================================================================//
 																			
void RedirigeInterruptions(void)
{
	QUICK_EXIT_NO_SAVE = 0;
	QUICK_EXIT_SAVE = 0;
	randomize();
	
	int1 = GetIntVec(AUTO_INT_1);
	int2 = GetIntVec(AUTO_INT_2);
	int5 = GetIntVec(AUTO_INT_5);
	
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec(AUTO_INT_2, DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
	
	GrayOn();
	
	plan0 = GetPlane(0);
	plan1 = GetPlane(1);
}

//===================================================================================//

void RestaureInterruptions(void)
{		
	GrayOff();
	
	SetIntVec(AUTO_INT_1, int1);
	SetIntVec(AUTO_INT_2, int2);
	SetIntVec(AUTO_INT_5, int5);
	
	OSTimerRestart(APD_TIMER);
}

//===================================================================================//